/*

Released by NZMac.com (http://www.nzmac.com)
under the Creative Commons Attribution-NonCommercial 2.0 license
http://creativecommons.org/licenses/by-nc/2.0/

You are free:
* to copy, distribute, display, and perform the work
* to make derivative works

Under the following conditions:
* Attribution. You must give the original authors credit.
* Non-commercial. You may not use this work for commercial purposes.

For any reuse or distribution, you must make clear to others the license
terms of this work.

Any of these conditions can be waived if you get permission from the
copyright holder.

Your fair use and other rights are in no way affected by the above.

Philip Roy - Initial code - http://www.bluengrey.com
Craig Stanton - Advanced Programming - http://craig.stanton.net.nz/
Cian Walsh - Widget graphics - http://www.afterglow.ie/

----------

* Portions Copyright  2005, Apple Computer, Inc.  All rights reserved.
* Inspiration from Julius Vu (JaRSS widget) and Wishingline.com (Xcode
template)
* Script to parse RSS XML data files written by Mark Wilton-Jones
  Script to import XML data files and make them available to JavaScript
written by Mark Wilton-Jones

  http://www.howtocreate.co.uk/jslibs/termsOfUse.html for terms of use



*/

/*****************************************************************************************

          Script to import XML data files and make them available to JavaScript

                     v2.0.3 written by Mark Wilton-Jones, 13/04/2004

 Updated 09/11/2004 to allow a delay for better response in browsers that use the iframe

Updated 02/07/2004 to provide native Safari 1.2 and Opera 7.6 support using XMLHttpRequest

                   Updated 24/07/2004 to prevent a Safari caching bug

      Updated 02/10/2004 to include support for older Internet Explorer XML objects

******************************************************************************************



Please see http://www.howtocreate.co.uk/jslibs/ for details and a demo of this script

Please see http://www.howtocreate.co.uk/tutorials/jsexamples/importingXML.html for a demo and description

Please see http://www.howtocreate.co.uk/jslibs/termsOfUse.html for terms of use



To use this, insert the following into the head of your document:



<script type="text/javascript"><!--

//for older browsers like Netscape 4 ... if you care

window.onerror = function () { return true; }

//--></script>

<script src="PATH TO SCRIPT/importxml.js" type="text/javascript"></script>



This header file provides one function:

var canItWork = importXML( string: locationOfXMLFile, string: nameOfFunction[, optional boolean: allowCache[, optional boolean: delay]] );

eg.

var canItWork = importXML( 'myXML.xml', 'runThis' );



To support (Internet) Explorer 5 on Mac, the XML file should use a stylesheet:

<?xml-stylesheet type="text/css" href="blank.css"?>

Although that stylesheet could in fact be completely empty. Failure to do this will produce errors when you

try to manipulate the DOM of the XML file.



When the xml file has loaded, the named function will be run, and will be passed a reference to the document

object of the XML file. You can then manipulate the data in the file using W3C DOM scripting.


Browsers may cache the XML files (with Safari, the import fails if the file is already cached by the current page).
To prevent this, the script adds a timestamp to the end of each request URL (changes every millisecond).
If you do not want this timestamp to be added, pass the value 'true' as a third parameter.
var canItWork = importXML( 'myXML.xml', 'runThis', true );

This is not recommended.


Browsers that use the iframe may have problems if the XML takes a long time to load, as they will attempt to
access the data before it is ready. If you know that this might happen, you can use the delay parameter to
make the script wait for the specified amount of time before attemting to use the data, hopefully giving the
XML the chance to load. For example, to introduce a 2 second delay:
var canItWork = importXML( 'myXML.xml', 'runThis', false, 2000 );

Widget Notes
************
v1.0 This widget was originaly based on the NZMac widget.
_______________________________________________________________________________________*/

var backImage = new Array(); // don't change this

// Background images

backImage[0] = "default.png";

var flipShown = false;

var animation = { duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement: null, timer: null };

var MWJ_ldD = [];

function importXML( oURL, oFunct, oNoRand, oDelay ) {

	//note: in XML importing event handlers, 'this' refers to window

	if( !oNoRand ) { oURL += ( ( oURL.indexOf('?') + 1 ) ? '&' : '?' ) + ( new Date() ).getTime(); } //prevent cache

	if( window.XMLHttpRequest ) {

		//alternate XMLHTTP request - Gecko, Safari 1.2+ and Opera 7.6+
		MWJ_ldD[MWJ_ldD.length] = new XMLHttpRequest();
		MWJ_ldD[MWJ_ldD.length-1].onreadystatechange = new Function( 'if( MWJ_ldD['+(MWJ_ldD.length-1)+'].readyState == 4 && MWJ_ldD['+(MWJ_ldD.length-1)+'].status < 300 ) { '+oFunct+'(MWJ_ldD['+(MWJ_ldD.length-1)+'].responseXML); }' );
		MWJ_ldD[MWJ_ldD.length-1].open("GET", oURL, true);
		MWJ_ldD[MWJ_ldD.length-1].send(null);
		return true;
	}
	if( !navigator.__ice_version && window.ActiveXObject ) {
		//the Microsoft way - IE 5+/Win (ICE produces errors and fails to use try-catch correctly)
		try { //IE Mac has the property window.ActiveXObject but produces errors if you try and use it
			try { var tho = new ActiveXObject( 'Microsoft.XMLDOM' ); //newer
			} catch(e) { var tho = new ActiveXObject( 'Msxml2.XMLHTTP' ); } //older
			MWJ_ldD[MWJ_ldD.length] = tho;
			MWJ_ldD[MWJ_ldD.length-1].onreadystatechange = new Function( 'if( MWJ_ldD['+(MWJ_ldD.length-1)+'].readyState == 4 ) { '+oFunct+'(MWJ_ldD['+(MWJ_ldD.length-1)+']); }' );
			MWJ_ldD[MWJ_ldD.length-1].load(oURL);

			return true;
		} catch(e) {}
	}
	if( document.createElement && document.childNodes ) {
		//load the XML in an iframe
		var ifr = document.createElement('DIV');
		ifr.style.visibility = 'hidden';
		ifr.style.position = 'absolute';

		ifr.style.top = '0px';
		ifr.style.left = '0px';
		//onload only fires in Opera so I use a timer for all
		if( !window.MWJ_XML_timer ) { window.MWJ_XML_timer = window.setInterval('MWJ_checkXMLLoad();',100); }
		ifr.innerHTML = '<iframe src="'+ oURL +'" name="MWJ_XML_loader_'+MWJ_ldD.length+'" height="0" width="0"><\/iframe>';
		MWJ_ldD[MWJ_ldD.length] = oFunct+'MWJ_SPLIT'+(oDelay?oDelay:1)+'';
		document.body.appendChild(ifr);
		return true;
	}
	return false;
}

function MWJ_checkXMLLoad() {
	//check if each imported file is available (huge files may not have loaded completely - nothing I can do - use the delay to help)
	for( var x = 0; x < MWJ_ldD.length; x++ ) { if( MWJ_ldD[x] && window.frames['MWJ_XML_loader_'+x] ) {
		setTimeout( MWJ_ldD[x].split('MWJ_SPLIT')[0] + '(window.frames.MWJ_XML_loader_'+x+'.window.document);', parseInt(MWJ_ldD[x].split('MWJ_SPLIT')[1]) );
		MWJ_ldD[x] = false;
	} }
}

// JavaScript Document
var month_names = new Array("janvier", "f&eacute;vrier", "mars", "avril", "mai", "juin", "juillet", "ao&ucirc;t", "septembre", "octobre", "novembre", "d&eacute;cembre");

var feedKey = 'savedFeedURL';
var timeKey = 'savedRefreshTime';
var headlinesKey = 'savedheadlines';



/* Apple Javascript from Dashboard Tutorial Document   */

if (window.widget) {
    widget.onshow = onshow;
}

function onshow() {
    back.style.display="none"; 
    front.style.display="block";
}

function setUpdatedText(){
	updateArea = document.getElementById('lastUpdate');
	
	updateDisplayText = 'Derni&egrave;re mise &agrave; jour: ';
	var dd=new Date;
	var dayOfMonth = dd.getDate();
	
	var hours = dd.getHours();

	var minutes = dd.getMinutes();
	if (minutes < 10){
		minutes = '0' + minutes;
	}

	updateDisplayText += dayOfMonth + ' ' + month_names[dd.getMonth()] + ' ' + dd.getFullYear() + ' ' + hours + ':' + minutes;


	updateArea.innerHTML = updateDisplayText;
	
}

function saveFeedPref(){
	if (window.widget){
		widget.setPreferenceForKey(document.formName.feedURL.value, feedKey);
		document.body.background = backImage[0];
	}
}

function saveFeedPref2(){
	if (window.widget){
		widget.setPreferenceForKey(document.formName2.feedURL2.value, feedKey);
		document.body.background = backImage[0];
	}
}

function saveTimePref(){
	if (window.widget){
		widget.setPreferenceForKey(document.formName.interv.value, timeKey);
	}
}

function saveheadlinesPref(){
	if (window.widget){
		widget.setPreferenceForKey(document.formName.headlines.value, headlinesKey);
	}
}

function restoreSavedPrefs(){
	updateArea = document.getElementById('lastUpdate');
	if (window.widget){
		savedTimeValue = widget.preferenceForKey(timeKey);
		savedheadlinesValue = widget.preferenceForKey(headlinesKey);
		
		if (savedTimeValue != ''){
			for( i = 0; i < document.formName.interv.length; i++){
				if (document.formName.interv.options[i].value == savedTimeValue){
					document.formName.interv.options[i].selected = true;
				} 
			}
		}
		
		if (savedheadlinesValue != ''){
			for( i = 0; i < document.formName.headlines.length; i++){
				if (document.formName.headlines.options[i].value == savedheadlinesValue){
					document.formName.headlines.options[i].selected = true;
				} 
			}
		}

	}
}

function restoreSavedPrefs2(){
	updateArea = document.getElementById('lastUpdate');
	if (window.widget){
		savedFeedValue = widget.preferenceForKey(feedKey);
		
		if (savedFeedValue != ''){
			for( i = 0; i < document.formName2.feedURL2.length; i++){
				if (document.formName2.feedURL2.options[i].value == savedFeedValue){
					document.formName2.feedURL2.options[i].selected = true;
					document.body.background = backImage[0];
				}
				else
				{
				   document.body.background = backImage[0];
				}
			}
		}

	}
}

function Go(){
	theForm = document.formName;
	if(window.myInterval){
		window.clearInterval(window.myInterval);
	}
	if(importXML(theForm.feedURL.value,'parseRSS',false,2000)){
		if(parseFloat(theForm.interv.value)){
			window.myInterval=window.setInterval('importXML(theForm.feedURL.value,\'parseRSS\',false,2000);',parseFloat(theForm.interv.value)*60000);
		}
	}
	else{
		alert('Your browser cannot import XML, so it cannot view RSS feeds using this script');
	}
	

}

function Go2(){
	theForm = document.formName;
	theForm2 = document.formName2;
	if(window.myInterval){
		window.clearInterval(window.myInterval);
	}
	if(importXML(theForm2.feedURL2.value,'parseRSS',false,2000)){
		if(parseFloat(theForm.interv.value)){
			window.myInterval=window.setInterval('importXML(theForm2.feedURL2.value,\'parseRSS\',false,2000);',parseFloat(theForm.interv.value)*60000);
		}
	}
	else{
		alert('Your browser cannot import XML, so it cannot view RSS feeds using this script');
	}
	

}

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");
	
	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	

	document.getElementById('fliprollie').style.display = 'none';
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if(window.widget)
		widget.prepareForTransition("ToFront");
			
	front.style.display = "block";
	back.style.display = "none";
	
	if(window.widget)
		setTimeout("widget.performTransition();", 0);
	Go();
}

function showfliprollie()
{
	document.getElementById('fliprollie').style.display = 'block';
}
function hidefliprollie()
{
	document.getElementById('fliprollie').style.display = 'none';
}

function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
	
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}

function mousemove(event)
{
	if (!flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit(event)
{
	if (flipShown)
	{
		// fade in the info button
		if (animation.timer != null)
		{
			clearInterval(animation.timer);
			animation.timer	 = null;
		}
		

		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}
